//Version 2.1
#include "WaveSurfaceKit.h"

//Water fall, composed of a set of small spheres (particles)

class WFElement{
	private:
		//Position of the sphere
		float pos_x;
		float pos_y;
		float pos_z;
		//Speed of the sphere
		float v_x;
		float v_y;
		float v_z;
		//Radius of the sphere
		float radius;
		//Initial speed in y direction
		float speed;
		//Initial position of the sphere
		//Can be used when the sphere reach the surface, to reuse it.
		float init_x;
		float init_y;
		float init_z;
		//Last position.If the particle goes beyond this point, we put it up back.
		float end_z;
		WaveSurfaceKit* water_down;
		WaveSurfaceKit* water_up;
		//Transform node,used to move the sphere
		SoTransform* transform;
	
	public:
		//Constructor.
		WFElement::WFElement(float pos_x, float pos_y, float pos_z, float radius, float speed, float end_z, WaveSurfaceKit * water_down, WaveSurfaceKit * water_up);
		//Add the sphere to the tree (coin3d)
		SoSeparator* add2tree();
		SoSeparator* outoftree();
		//Move the position of the sphere
		void move(float pos_x, float pos_y, float pos_z);
		//Update the position of the sphere using physics rules
		void WFElement::update(float time);
};