// Version 2.1
#include "WJElement.h"

//Constructor
WJElement::WJElement(float pos_x, float pos_y, float pos_z, float radius, float speed, float end_z,WaveSurfaceKit * water){
  this->pos_x=pos_x;
  this->pos_y=pos_y;
  this->pos_z=pos_z;
  this->radius=radius;
  init_x=pos_x;
  init_y=pos_y;
  init_z=pos_z;
  init_speed=speed;
  v_x=0;
  v_y=0;
  v_z=speed;
  this->end_z=end_z;
  this->water=water;
  fuzzy=0;
  transparency=0.7f;
  sphere_visible=1;

}

//Add the sphere to the tree (coin3d)
SoSeparator* WJElement::add2tree(){
  SoSeparator* sep = new SoSeparator();

  mat= new SoMaterial();
  mat->emissiveColor.setValue(0.9f,0.9f,0.9f);
  mat->specularColor.setValue(0.9f,0.9f,0.9f);
  mat->transparency=0.7f;

  SoScale* scale = new SoScale();
  scale->scaleFactor.setValue(radius,radius,radius);

  transform = new SoTransform();
  transform->translation.setValue(pos_x,pos_y,pos_z);

  sep->addChild(mat);
  sep->addChild(transform);
  sep->addChild(scale);
  sep->addChild(new SoSphere());
  return sep;
}

//Move the position of the sphere
void WJElement::move(float pos_x, float pos_y, float pos_z){
	this->pos_x=pos_x;
	this->pos_y=pos_y;
	this->pos_z=pos_z;
	transform->translation.setValue(pos_x,pos_y,pos_z);
}

//Update the position of the sphere using physics rules
void WJElement::update(float t,char visible){

	pos_y+=v_y*t;
	pos_z+=v_z*t;

	v_z-=radius*10*t;

	// Simulate Lennard-Jones
	if ((v_z<0) & fuzzy!=1){

		pos_x+=random_val(0.0f,0.15f);
		pos_y+=random_val(0.0f,0.15f);
		fuzzy=1;
	}

	//if the object reach the surface of the water,put it up back
	if ((pos_z<end_z)& (v_z<0)){
		if (sphere_visible==1){
			transparency=0.7f;
			water->reshape(pos_x,pos_y);
		}else{
			transparency=1.0f;
		}
		pos_x=init_x, pos_y=init_y, pos_z=init_z, v_z=init_speed, fuzzy=0;
		sphere_visible=visible;
		mat->transparency=transparency;
	}
	WJElement::move(pos_x,pos_y,pos_z);
}

