//Version 2.1
#include <Inventor/Win/SoWin.h>
#include <Inventor/Win/viewers/SoWinExaminerViewer.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoTexture2.h>
#include <Inventor/nodes/SoScale.h>
#include <Inventor/nodes/SoTransform.h>
#include <Inventor/nodes/SoSphere.h>
#include <Inventor/nodes/SoTranslation.h>
#include <Inventor/nodes/SoBaseColor.h>
#include <Inventor/nodes/SoMaterial.h>


#include "WaveSurfaceKit.h"
#include "random_val.h"

class WJElement{
	private:
		//Position of the sphere
		float pos_x;
		float pos_y;
		float pos_z;
		//Speed of the sphere
		float v_x;
		float v_y;
		float v_z;
		//Radius of the sphere
		float radius;
		//Initial position of the sphere
		//Can be used when the sphere reach the surface, to reuse it.
		float init_x;
		float init_y;
		float init_z;
		float init_speed;
		//Last position.If the particle goes beyond this point, we put it up back.
		float end_z;
		//Variable to pertubate the position of particles (simulate Norah Jones)
		char fuzzy;
		//Value of the sphere transparency
		float transparency;
		//Set if the sphere should be display
		char sphere_visible;

		WaveSurfaceKit* water;
		//Transform node,used to move the sphere
		SoTransform* transform;
		//Material node, used to change the transparency
		SoMaterial* mat;
	
	public:
		//Constructor.
		WJElement(float pos_x, float pos_y, float pos_z, float radius, float speed, float end_z, WaveSurfaceKit * water);
		//Add the sphere to the tree (coin3d)
		SoSeparator* add2tree();
		//Move the position of the sphere
		void move(float pos_x, float pos_y, float pos_z);
		//Update the position of the sphere using physics rules
		void update(float t,char visible);
};